#!/usr/bin/perl

sub DisplayTemplateList
{
  print "<CENTER>\n";
  print "<H2>Templates</H2>\n";
  &PrintToolbar("New","Delete","Copy","Configure","Sort");
  print "<FORM NAME=TEMPLATELISTFORM ACTION=\"uda2.pl\">\n";
  print "<INPUT TYPE=HIDDEN NAME=module VALUE=templates>\n";
  print "<INPUT TYPE=HIDDEN NAME=action VALUE=none>\n";
  print "<INPUT TYPE=HIDDEN NAME=template VALUE=none>\n";
  print "</FORM>\n";
  
  print "<script language='javascript' src='/js/table.js'></script>\n";
  print "<script language='javascript' src='/js/templates.js'></script>\n";
  print "<BR>\n";
  print " <TABLE BORDER=1 ID='templatesorttable'>\n";
  print "<TR CLASS=tableheader><TD>Template</TD><TD>OS</TD><TD>Flavor</TD><TD>Publish</TD><TD>MAC</TD><TD>Description</TD></TR>\n";
  local(%templateconfig)=&GetTemplateHTMLConfig();
  local(%templatesortorder)=&GetTemplateSortOrder();
  #for $curtemplateconfig (keys(%templateconfig))
  for $curtemplateconfig (sort(keys(%templatesortorder)))
  {
    if (defined($templateconfig{$templatesortorder{$curtemplateconfig}}))
    {
      print "<TR onclick='SelectRow(this)' ID=$templatesortorder{$curtemplateconfig}>$templateconfig{$templatesortorder{$curtemplateconfig}}</TR>\n";
      delete($templateconfig{$templatesortorder{$curtemplateconfig}});
    }
  }
  # put the templates not in the sortorder at the end of the table in random order
  for $mytemplateconfig (sort(keys(%templateconfig)))
  {
    print "<TR onclick='SelectRow(this)' ID=$mytemplateconfig>$templateconfig{$mytemplateconfig}</TR>\n";
  }
  print "</TABLE>\n";
  print "</TABLE>\n";
  print "</CENTER>\n";
  return 0;
}

sub ApplySortTemplateList
{
  local($sort)=$formdata{SORT};
  if ($sort eq "none")
  {
    print "<LI>OK no sortstring found, doing nothing\n";
    return 0;
  }
  local(@sortarray)=split(";",$sort);
  local($result)=&WriteTemplateSortFile(@sortarray);
  if ($result)
  {
    &PrintError("Could not save the template sort");
    return 1;
  }
  local($result)=&WriteDefaultFile();
  if ($result)
  {
    &PrintError("Could not write sorted PXE menu file");
    return 1;
  }

  &DisplayTemplateList();
  return 0;
}

sub SortTemplateList
{
  print "<CENTER>\n";
  print "<H2>Sort Templates</H2>\n";
  &PrintToolbar("Save","Cancel","Up","Down");
  print "<FORM NAME=TEMPLATELISTSORTFORM ACTION=\"uda2.pl\">\n";
  print "<INPUT TYPE=HIDDEN NAME=module VALUE=templates>\n";
  print "<INPUT TYPE=HIDDEN NAME=action VALUE=sort>\n";
  print "<INPUT TYPE=HIDDEN NAME=button VALUE=none>\n";
  print "<INPUT TYPE=HIDDEN NAME=SORT VALUE=none>\n";
  print "</FORM>\n";
  print "<script language='javascript' src='/js/sorttemplates.js'></script>\n";
  print "<script language='javascript' src='/js/tablesort.js'></script>\n";
  print "<script language='javascript' src='/js/table.js'></script>\n";
  print "<BR>\n";
  print " <TABLE BORDER=1 ID='templatesorttable'>\n";
  print "<TR CLASS=tableheader><TD>Template</TD><TD>OS</TD><TD>Flavor</TD><TD>Publish</TD><TD>MAC</TD><TD>Description</TD></TR>\n";
  local(%templateconfig)=&GetTemplateHTMLConfig();
  local(%templatesortorder)=&GetTemplateSortOrder();
  for $curtemplateconfig (sort(keys(%templatesortorder)))
  {
    if (defined($templateconfig{$templatesortorder{$curtemplateconfig}}))
    {
      print "<TR onclick='SelectRow(this)' ID=$curtemplateconfig>$templateconfig{$templatesortorder{$curtemplateconfig}}</TR>";
      delete($templateconfig{$templatesortorder{$curtemplateconfig}});
    }
  }
  for $mytemplateconfig (sort(keys(%templateconfig)))
  {
    print "<TR onclick='SelectRow(this)' ID=$mytemplateconfig>$templateconfig{$mytemplateconfig}</TR>\n";
  }
  print "</TABLE>\n";

  print "</TABLE>\n";
  print "</CENTER>\n";
}

sub NewTemplate
{
  require "os.pl";
  require "config.pl";
  print "<CENTER>\n";
  print "<H2>New Template Wizard Step 1</H2>\n";
  &PrintToolbar("Next","Cancel");
  &PrintJavascriptArray("osarray",&GetOSList());
  &PrintJavascriptArray("flavorarray",&GetOSFlavorList());
  print "<script language='javascript' src='/js/loadvalues.js'></script>\n";
  print "<script language='javascript' src='/js/newtemplate.js'></script>\n";
  print "<script language='javascript' src='/js/validation.js'></script>\n";
  print "<FORM NAME=WIZARDFORM ACTION=\"uda2.pl\">\n";
  print "<INPUT TYPE=HIDDEN NAME=module VALUE=templates>\n";
  print "<INPUT TYPE=HIDDEN NAME=action VALUE=new>\n";
  print "<INPUT TYPE=HIDDEN NAME=button VALUE=none>\n";
  print "<INPUT TYPE=HIDDEN NAME=step VALUE=1>\n";
  print "<TABLE>\n";
  print "<TR><TD>Template Name</TD><TD><INPUT TYPE=TEXT NAME=TEMPLATENAME ID=TEMPLATENAME></TD></TR>\n";
  print "<TR><TD>Description</TD><TD><INPUT TYPE=TEXT NAME=DESCRIPTION></TD></TR>\n";
  print "<TR><TD>Operating System</TD><TD><SELECT NAME=OS ID=OS ONCHANGE='ReloadIndexedValues(\"OSFLAVOR\",flavorarray,this.options[this.selectedIndex].value);'></SELECT></TD></TR>\n";
  print "<TR><TD>Flavor</TD><TD><SELECT NAME=OSFLAVOR ID=OSFLAVOR></SELECT></TD></TR>\n";
  print "<TR><TD>Bind to MAC</TD><TD><INPUT TYPE=TEXT NAME=MAC></TD></TR>\n";
  print "<TR><TD>Generate MAC Based PXE config</TD><TD><INPUT TYPE=TEXT NAME=GENERATEMAC></TD></TR>\n";
  print "<TR><TD>Publish</TD><TD><INPUT TYPE=CHECKBOX NAME=PUBLISH CHECKED></TD></TR>\n";
  print "</TABLE>\n";
  print "</FORM>\n";
  print "</CENTER>\n";
  print "<script language='javascript'>\n";
  print "LoadValues(\"OS\",osarray);\n";
  print "var OSBox=document.getElementById(\"OS\");\n";
  print "ReloadIndexedValues(\"OSFLAVOR\",flavorarray,OSBox.options[OSBox.selectedIndex].value);\n";
  print "</script>\n";
  return 0;
}


sub CopyTemplate
{
  local($template)=$formdata{template};
  local(%info)=&GetTemplateInfo($template);

  print "<CENTER>\n";
  print "<H2>Copy Template $template</H2>\n";
  &PrintToolbar("Save","Cancel");
  print "<script language='javascript' src='/js/copytemplate.js'></script>\n";
  print "<script language='javascript' src='/js/validation.js'></script>\n";
  
  print "<FORM NAME=WIZARDFORM ACTION=\"uda2.pl\">\n";
  print "<INPUT TYPE=HIDDEN NAME=module VALUE=templates>\n";
  print "<INPUT TYPE=HIDDEN NAME=action VALUE=copy>\n";
  print "<INPUT TYPE=HIDDEN NAME=button VALUE=none>\n";
  print "<INPUT TYPE=HIDDEN NAME=template VALUE=$template>\n";
  print "<INPUT TYPE=HIDDEN NAME=OS VALUE=$info{OS}>\n";
  print "<INPUT TYPE=HIDDEN NAME=FLAVOR VALUE=$info{FLAVOR}>\n";
  print "<TABLE>\n";
  print "<TR><TD>Template Name</TD><TD><INPUT TYPE=TEXT NAME=NEWTEMPLATENAME VALUE=\"CopyOf$template\">\n";
  print "<TR><TD>Description</TD><TD><INPUT TYPE=TEXT NAME=NEWDESCRIPTION VALUE=\"$info{DESCRIPTION}\"></TD></TR>\n";
  print "<TR><TD>OS</TD><TD>$info{OS}</TD></TR>\n";
  print "<TR><TD>Flavor</TD><TD>$info{FLAVOR}</TD></TR>\n";
  print "<TR><TD>MAC</TD><TD><INPUT TYPE=TEXT NAME=NEWMAC VALUE=\"$info{MAC}\"></TD></TR>\n";
  local($publish)="";
  if ($info{PUBLISH} eq "ON")
  {
    $publish="CHECKED";
  }
  print "<TR><TD>Publish</TD><TD><INPUT TYPE=CHECKBOX NAME=PUBLISH $publish></TD></TR>\n";
  print "<TR><TD>Copy Subtemplates</TD><TD><INPUT TYPE=CHECKBOX NAME=COPYSUBTEMPLATES></TD></TR>\n";
  print "</TABLE>\n";
  print "</FORM>\n";
  print "</CENTER>\n";

  return 0;
}

sub ApplyCopyTemplate
{

 local($orgtemplate)=$formdata{template};
 local($desttemplate)=$formdata{NEWTEMPLATENAME};
 local($description)=$formdata{NEWDESCRIPTION};
 local($mac)=$formdata{NEWMAC};
 local($os)=$formdata{OS};
 local($flavor)=$formdata{FLAVOR};
 local($publish)="ON";
 if (!defined($formdata{PUBLISH}))
 {
   $publish="OFF";
 }
 local($generatemac)="ON";
 if (!defined($formdata{GENERATEMAC}))
 {
   $generatemac="OFF";
 } 
  # Check The Template name first
  local($result)=&CheckTemplateName($desttemplate);
  if ($result)
  {
    return 1;
  }

 local(%info)=&GetTemplateInfo($orgtemplate);
 $info{TEMPLATE}=$desttemplate;
 $info{MAC}=$mac;
 $info{PUBLISH}=$publish;
 $info{DESCRIPTION}=$description;
 $info{OS}=$os;
 $info{FLAVOR}=$flavor;
 $info{GENERATEMAC}=$generatemac;

  if (defined(&{$info{OS}."_GetDefaultConfigFile1"}))
  {
    $info{CONFIGFILE1}=&{$info{OS}."_GetDefaultConfigFile1"}($desttemplate);
    if ($result) { return $result };
  }

  if (defined(&{$info{OS}."_GetDefaultConfigFile2"}))
  {
    $info{CONFIGFILE2}=&{$info{OS}."_GetDefaultConfigFile2"}($desttemplate);
    if ($result) { return $result };
  }

  if (defined(&{$info{OS}."_GetDefaultPublishDir"}))
  {
    $info{PUBLISHDIR}=&{$info{OS}."_GetDefaultPublishDir"}($desttemplate);
    if ($result) { return $result };
  }

  if (defined(&{$info{OS}."_GetDefaultPublishDir2"}))
  {
    $info{PUBLISHDIR2}=&{$info{OS}."_GetDefaultPublishDir2"}($desttemplate);
    if ($result) { return $result };
  }

  if (defined(&{$info{OS}."_GetDefaultPublishFile"}))
  {
    $info{PUBLISHFILE1}=&{$info{OS}."_GetDefaultPublishFile"}($desttemplate);
    if ($result) { return $result };
  }

  if (defined(&{$info{OS}."_GetDefaultPublishFile2"}))
  {
    $info{PUBLISHFILE2}=&{$info{OS}."_GetDefaultPublishFile2"}($desttemplate);
    if ($result) { return $result };
  }

 if (defined($formdata{COPYSUBTEMPLATES}))
 {
   local($orgsubfile)=$TEMPLATECONFDIR."/$orgtemplate.sub";
   if ( -f $orgsubfile )
   {
     local($destsubfile)=$TEMPLATECONFDIR."/$desttemplate.sub";
     local($command)="cp $orgsubfile $destsubfile";
     local($result)=&RunCommand($command,"Copying $orgsubfile to $orgdestfile");
     if ($result)
     {
       &PrintError("Could not copy subtemplates for $desttemplate");
       return 1;
     }
   }
 }

 local($result)=&WriteTemplateInfo(%info);
 if ($result)
 {
   &PrintError("Could not Write Template info file for $desttemplate");
   return 1;
 }

 local($requirefile)=$OSDIR."/".$info{OS}.".pl";
 require $requirefile;
 local($result)=&{$info{OS}."_CopyTemplate"}($orgtemplate,$desttemplate,%info);
 if ($result)
 {
   &PrintError("Could not Copy $info{OS} related info for template $desttemplate");
   return 1;
 }

 local($result)=&PublishTemplate($desttemplate);
 if ($result) 
 { 
   &PrintError("Could not publish template $desttemplate");
   return 1;
 }
 local($result)=&WriteDefaultFile();
 if ($result) 
 { 
   &PrintError("Could not write default file");
   return 1;
 }
 
 &PrintSuccess("Copied template $orgtemplate to $desttemplate");

 return 0;
}


sub ApplyEditTemplate
{

 local($orgtemplate)=$formdata{template};
 local($template)=$formdata{NEWTEMPLATE};
 local($description)=$formdata{NEWDESCRIPTION};
 local($mac)=$formdata{NEWMAC};
 local($os)=$formdata{OS};
 local($flavor)=$formdata{NEWFLAVOR};
 local($pxepasswd)=$formdata{NEWPXEPASSWD};

 local($publish)="ON";
 if (!defined($formdata{NEWPUBLISH}))
 {
   $publish="OFF";
 }
 local($generatemac)="ON";
 if (!defined($formdata{NEWGENERATEMAC}))
 {
   $generatemac="OFF";
 }
 local($separator)="MENU SEPARATOR";
 if (!defined($formdata{NEWSEPARATOR}))
 {
   $separator="#";
 }
 local(%info)=&GetTemplateInfo($orgtemplate);
 $info{TEMPLATE}=$template;
 $info{MAC}=$mac;
 $info{PUBLISH}=$publish;
 $info{DESCRIPTION}=$description;
 $info{OS}=$os;
 $info{FLAVOR}=$flavor;
 $info{SEPARATOR}=$separator;
 $info{GENERATEMAC}=$generatemac;
 if ($pxepasswd ne "")
 {
   $info{PXEPASSWD}="menu passwd ".$pxepasswd;
 } else {
   $info{PXEPASSWD}="# no password";
 }

 local($result)=&WriteTemplateInfo(%info);
 if ($result) { return $result ; }

 local($subtemplates)=$formdata{SUBTEMPLATEINFO};
 local($result)=&SaveSubTemplateFile($template,$subtemplates);
 if ($result) { return $result ; }

 local($requirefile)=$OSDIR."/".$info{OS}.".pl";
 require $requirefile;
 if (defined(&{$info{OS}."_ApplyConfigureTemplate"}))
 {
   local($result)=&{$info{OS}."_ApplyConfigureTemplate"}($template,%info);
   if ($result) { return $result ; }
 }

 if ($publish eq "ON")
 {
   local($result)=&PublishTemplate($template);
   if ($result) { return $result };
 } else {
   local($result)=&UnPublishTemplate($template);
   if ($result) { return $result };
 }

 if ($template ne $orgtemplate)
 {
   local($result)=&DeleteTemplate($orgtemplate);
   if ($result) { return $result };
 }

 local($result)=&WriteDefaultFile();
 if ($result) { return $result };

 return 0;
}

sub PublishAllTemplates
{
  local(%templates)=&GetTemplateHTMLConfig();
  local($overallresult)=0; 
  for $template (keys(%templates))
  {
    local($result)=&PublishTemplate($template);
    $overallresult+=$result;
  }
  local($result)=&WriteDefaultFile();
  $overallresult+=$result;
  return $overallresult;
}

sub UnPublishTemplate
{
  local($template)=shift;
  local(%info)=&GetTemplateInfo($template);

  for $infokey (keys(%info))
  {
    if ($infokey =~ /PUBLISHDIR[0-9]+/)
    {
      local($deletedir)=$info{$infokey};
      local($result)=&RunCommand("rm -rf $deletedir","Deleting $deletedir");
      if ($result)
      {
        return $result;
      }
    }
  }

  local($result)=&RunCommand($command,"Removing publishdir $info{PUBLISHDIR1}");
  if ($result) { return $result; }

  local($result)=&DeleteTemplatePXEMenu($template);
  if ($result) { return $result; }

  local($requirefile)=$OSDIR."/".$info{OS}.".pl";
  require $requirefile;
  if (defined(&{$info{OS}."_UnPublishTemplate"}))
  {
    local($result)=&{$info{OS}."_UnPublishTemplate"}($template);
    if ($result) { return $result };
  } 

  return 0;
}

sub PublishTemplate
{
  local($template)=shift;
 
  local(%info)=&GetTemplateInfo($template);

  if ($info{PUBLISH} eq "ON")
  {
     # Create the publish directry for this template
     local($result)=&CreateDir($info{PUBLISHDIR1});
     if ($result)
     {
       &PrintError("Could not create directory $info{PUBLISHDIR1}");
       return 1;
     }

    local(%subinfo)=&GetAllSubTemplateInfo($template);

    local(@configfile)=&GetConfigFile($info{CONFIGFILE1});
    local(@indexes)=keys(%subinfo);
    if ($#indexes<0)
    {
       # print "<LI>Publishsing default subtemplate for $template\n";
       $info{SUBTEMPLATE}="default";
       local($publishfile)=&FindAndReplace($info{PUBLISHFILE1},%info);
       local($result)=open(PFILE,">$publishfile");
       for $line (@configfile)
       {
        local($newline)=&FindAndReplace($line,%info);
        print PFILE $newline;
       }
       close(PFILE);
    } else  {
      local($headerline)=$subinfo{__HEADER__};
      for $sub (keys(%subinfo))
      {
       if ($sub ne "__HEADER__")
       {
         # print "<LI>Publishsing subtemplate $sub\n";
         local(%subinfo)=&GetSubTemplateInfo($headerline,$subinfo{$sub},%info);
     
         local($publishfile)=&FindAndReplace($subinfo{PUBLISHFILE1},%subinfo);
  
         # print "<LI>Current publishfile = $publishfile\n";
         local($result)=open(PFILE,">$publishfile");
         for $line (@configfile)
         {
           local($newline)=&FindAndReplace($line,%subinfo);
           print PFILE $newline;
         }
         close(PFILE);
        }
      }
    }

   if (defined(&{$info{OS}."_PublishTemplate"}))
   {
       local($result)=&{$info{OS}."_PublishTemplate"}($template);
       if ($result) { return $result };
   }

   local($result)=&WriteTemplatePXEMenu($template,%info);
   if ($result) { return $result };
  }

  return 0;
}

sub DeleteTemplate
{
  local($template)=@_;
  local(%info)=&GetTemplateInfo($template);
  local($os)=$info{OS}; 
  local($requirefile)=$OSDIR."/".$os.".pl";
  require $requirefile;
  &{$os."_DeleteTemplate"}($template);

  for $infokey (keys(%info))
  {
    if ($infokey =~ /CONFIGFILE[0-9]+/)
    {
      local($deletefile)=$info{$infokey};
      &RunCommand("rm $deletefile","Deleting $deletefile");
    }
  }

  local($result)=&UnPublishTemplate($template);
  if ($result)
  {
     &PrintError("Could not unpublish template $template");
     return 1;
   }

  local($result)=&DeleteTemplateDatFile($template);
  if ($result)
  {
     &PrintError("Could not remove template dat file for template $template");
     return 1;
   }

  local($result)=&DeleteSubtemplateFile($template);
  if ($result)
  {
     &PrintError("Could not remove subtemplate file for $template");
     return 1;
  }

  local($result)=&WriteDefaultFile();
   if ($result)
   {
     &PrintError("Could not write default file");
     return 1;
   }

  return 0;
}

sub ConfigureTemplate
{
  local($template)=$formdata{template};
  local(%info)=&GetTemplateInfo($template);
  local($requirefile)=$OSDIR."/".$info{OS}.".pl";
  require $requirefile;
  print "<CENTER>\n";
  print "<H2>Configure template $template</H2>\n";
  &PrintToolbar("Save","Cancel");
  print "<BR>\n";
  print "<TABLE WIDTH=600px HEIGHT=600px><TR CLASS=tabbed>\n";
  print "<TD ALIGN=CENTER ONCLICK=\"SelectTab(this);\" ID=general CLASS=tab><B>General</B></TD>\n";
  print "<TD ALIGN=CENTER ONCLICK=\"SelectTab(this);\" ID=subtemplates CLASS=tab><B>Subtemplates</B></TD>\n";
  print "<TD ALIGN=CENTER ONCLICK=\"SelectTab(this);\" ID=advanced CLASS=tab><B>Advanced</B></TD>\n";

  local($numtabs)=3;
  if (defined(&{$info{OS}."_ConfigureTemplate2"}))
  {
    print "<TD ALIGN=CENTER ONCLICK=\"SelectTab(this);\" ID=advanced2 CLASS=tab><B>More...</B></TD>\n";
    $numtabs++;
  }
  print "</TR>\n";

  print "<TR><TD VALIGN=TOP COLSPAN=$numtabs CLASS=tabcontent> \n";
 # STYLE=\"border-style: none solid solid solid; border-width: thin\" >\n";
  print "<DIV ID=general_div STYLE=\"display:block\">\n";
  print "<script language='javascript' src='/js/configuretemplates.js'></script>\n";
  print "<script language='javascript' src='/js/loadvalues.js'></script>\n";
  print "<script language='javascript' src='/js/validation.js'></script>\n";
  &PrintJavascriptArray("flavorarray",&GetOSFlavorList());
  print "<FORM NAME=CONFIGURETEMPLATEFORM ACTION=\"uda2.pl\" METHOD=POST>\n";
  print "<INPUT TYPE=HIDDEN NAME=module VALUE=templates>\n";
  print "<INPUT TYPE=HIDDEN NAME=action VALUE=none>\n";
  print "<INPUT TYPE=HIDDEN NAME=template VALUE=$template>\n";
  print "<INPUT TYPE=HIDDEN NAME=OS VALUE=$info{OS}>\n";
  print "<INPUT TYPE=HIDDEN NAME=FLAVOR VALUE=$info{FLAVOR}>\n";
  print "<TABLE>\n";
  print "<TR><TD>Template Name</TD><TD><INPUT TYPE=TEXT NAME=NEWTEMPLATE VALUE=\"$template\">\n";
  print "<TR><TD>Description</TD><TD><INPUT TYPE=TEXT NAME=NEWDESCRIPTION VALUE=\"$info{DESCRIPTION}\"></TD>
</TR>\n";
  print "<TR><TD>OS</TD><TD>$info{OS}</TD></TR>\n";
  # print "<TR><TD>Flavor</TD><TD>$info{FLAVOR}</TD></TR>\n";
  print "<TR><TD>Flavor</TD><TD><SELECT NAME=NEWFLAVOR ID=NEWFLAVOR></SELECT></TD></TR>\n";
  print "<TR><TD>MAC</TD><TD><INPUT TYPE=TEXT NAME=NEWMAC VALUE=\"$info{MAC}\"></TD></TR>\n";
  local($checked)="CHECKED";
  if ($info{GENERATEMAC} eq "OFF")
  {
    $checked="";
  }
  print "<TR><TD>Generate Mac-based PXE Boot Configuration(s)</TD><TD><INPUT TYPE=CHECKBOX NAME=NEWGENERATEMAC $checked></TD></TR>\n";
  local($checked)="CHECKED";
  if ($info{PUBLISH} eq "OFF")
  {
    $checked="";
  }
  print "<TR><TD>Publish</TD><TD><INPUT TYPE=CHECKBOX NAME=NEWPUBLISH $checked></TD></TR>\n";

  local($checked)="";
  if ($info{SEPARATOR} eq "MENU SEPARATOR")
  {
    $checked="CHECKED";
  }
  print "<TR><TD>PXE menu separator</TD><TD><INPUT TYPE=CHECKBOX NAME=NEWSEPARATOR $checked></TD></TR>\n";
  $info{PXEPASSWD}=~s/^menu passwd //g;
  if ($info{PXEPASSWD} =~ /^# no password/)
  {
    $info{PXEPASSWD}="";
  }
  print "<TR><TD>PXE password</TD><TD><INPUT TYPE=TEXT NAME=NEWPXEPASSWD VALUE=\"$info{PXEPASSWD}\"></TD></TR>\n";

  print "</TABLE>\n";
  print "</DIV>\n";
  print "<DIV ID=subtemplates_div STYLE=\"display:none\">\n";
  &ViewSubTemplates($template);
  print "</DIV>\n";
  print "<DIV ID=advanced_div STYLE=\"display:none\">\n";

  if (defined(&{$info{OS}."_ConfigureTemplate"}))
  {
    local($result)=&{$info{OS}."_ConfigureTemplate"}($template,%info);
    if ($result) { return $result; }
  }

  print "</DIV>\n";

  print "<DIV ID=advanced2_div STYLE=\"display:none\">\n";
  if (defined(&{$info{OS}."_ConfigureTemplate2"}))
  {
    local($result)=&{$info{OS}."_ConfigureTemplate2"}($template,%info);
    if ($result) { return $result; }
  }
  print "</DIV>\n";

  print "</FORM>\n";
  print "</TD></TR></TABLE>";
  print "<script language='javascript'>ReloadIndexedValues(\"NEWFLAVOR\",flavorarray,\"$info{OS}\");</script>\n";
  print "<script language='javascript'>PreSelect(\"NEWFLAVOR\",\"$info{FLAVOR}\");</script>\n";
  print "<script language='javascript'>SelectTab(document.getElementById('general'));</script>\n";
  return 0;
}

sub ConfigureTemplateAdvanced
{
  local($template)=$formdata{template};
  local(%info)=&GetTemplateInfo($template);

  local($os)=$info{OS};
  local($requirefile)=$OSDIR."/".$os.".pl";
  require $requirefile;
  &{$os."_ConfigureTemplate"}($template,%info);

  return 0;
}

sub WriteTemplatePXEMenu
{
  local($template,%info)=@_;

  local($os)=$info{OS};
  local($requirefile)=$OSDIR."/".$os.".pl";
  require $requirefile;
  local($result)==&{$os."_WriteTemplatePXEMenu"}($template);
  return 0;
}


sub DeleteTemplatePXEMenu
{
  local($template)=@_;
  local($templatepxefile)=$PXETEMPLATEDIR."/$template.menu";
  local($result)=&RunCommand("rm -f $templatepxefile");
  return $result;
}

sub ViewSubTemplates
{
  local($template)=shift;
  print "<CENTER>\n";
  # print "<script language='javascript' src='/js/subtemplates.js'></script>\n";
  print "<script language='javascript' src='/js/validatesubtemplates.js'></script>\n";
  print "<DIV ID=SUBTEMPLATEEDITDIV STYLE='display:block'>\n";
  &PrintToolbar("Edit","Download");
  print "<BR><BR>\n";
  print " <TABLE BORDER=1>\n";
  local(%templatesort)=&GetSubTemplateSort($template);
  local(%templateconfig)=&GetSubTemplateHTMLConfig($template);
  local(@fileinfo)=&GetSubTemplateFile($template);
  print "<TR CLASS=tableheader>$templateconfig{__HEADER__}</TR>\n";
  for $curtemplateconfig (sort(keys(%templatesort)))
  {
      print "<TR onclick='SelectRow(this)' ID=$curtemplateconfig>$templateconfig{$templatesort{$curtemplateconfig}}</TR>\n";
  }
  print "</TABLE>\n";
  print "</DIV>\n";
  print "<DIV ID=SUBTEMPLATEMANUALDIV STYLE='display:none'>\n";
  print "<H3>Subtemplate manual edit</H3>\n";
  print "<TEXTAREA WRAP=OFF ROWS=20 COLS=60 NAME=SUBTEMPLATEINFO>\n";
  for $line (@fileinfo)
  {
    print $line;
  }
  print "</TEXTAREA>\n";
  &PrintToolbar("Back");
  print "</DIV>\n";
  print "</CENTER>\n";
 return 0;
}

sub EditSubTemplates
{
  local($template)=shift;
  local(@fileinfo)=&GetSubTemplateFile($template);
  print "<CENTER>\n";
  print "<DIV ID=SUBTEMPLATEEDITDIV STYLE='display:block'>\n";
  &PrintToolbar("Upload","Download");
  # print "<script language='javascript' src='/js/subtemplates.js'></script>\n";
  # print "<script language='javascript' src='/js/editsubtemplates.js'></script>\n";
  # print "<FORM NAME=SUBTEMPLATELISTFORM METHOD=POST ACTION=\"uda2.pl\">\n";
  # print "<INPUT TYPE=HIDDEN NAME=module VALUE=templates>\n";
  # print "<INPUT TYPE=HIDDEN NAME=action VALUE=subtemplate>\n";
  # print "<INPUT TYPE=HIDDEN NAME=template VALUE=$template>\n";
  # print "<INPUT TYPE=HIDDEN NAME=button VALUE=none>\n";
  print "<TEXTAREA WRAP=OFF ROWS=30 COLS=60 NAME=SUBTEMPLATEINFO>";
  for $line (@fileinfo)
  {
    print $line;
  }
  print "</TEXTAREA>\n";
  print "</DIV>\n";
  print "<DIV ID=SUBTEMPLATEUPLOADDIV STYLE='display:none'>\n";
  print "<H3>Subtemplate file upload</H3>\n";
  print "Browse for the file to upload and click Save to start the upload and save all the change made in the configration<BR><BR>\n";
  print "Warning: manual changes made in the subtemplate configuration tab will be lost!<BR><BR>\n";
  print "<INPUT TYPE=FILE NAME=SUBTEMPLATEBROWSE VALUE=Browse>\n";
  print "<BR><BR>\n";
  &PrintToolbar("Back");
  print "</DIV>\n";
  # print "</FORM>\n";
  return 0;
}

sub SaveSubTemplates
{
  local($template)=shift;
  local($info)=$formdata{SUBTEMPLATEINFO};
  &SaveSubTemplateFile($template,$info);
  return 0;
}

sub CopySubTemplates
{
  local($orgtemplate,$desttemplate)=@_;
  local($orgfile)=
  local(@fileinfo)=&GetSubTemplateFile($orgtemplate);
  &SaveSubTemplateFile($desttemplate,$info);
  return 0;
}

sub DownloadSubTemplates
{
  local($template)=@_;
  local($subtemplatefile)="$TEMPLATECONFDIR/$template.sub";
  local($result)=open(STFILE,$subtemplatefile);
  local(@thefile)=<STFILE>;
  close(STFILE);
  print "Content-Type:application/x-download\n";  
  print "Content-Disposition:attachment;filename=$template.sub\n\n";
  print @thefile;
}

sub WriteTemplatePXEMenu
{
  local($template)=shift;
  local($passwordenabled)=0;
  local(%info)=&GetTemplateInfo($template);
  local(%subs)=&GetAllSubTemplateInfo($template);

  local(%subsort)=&GetSubTemplateSort($template);
  local(@sublist)=keys(%subs);

  local($templatepxefile)=$PXETEMPLATEDIR."/$template.menu";

  local($result)=opendir(NEWDIR,"$PXETEMPLATEDIR");
  while($newfn=readdir(NEWDIR))
  {
     if ($newfn =~ /^$template\.([0-9]{2}-[0-9A-Fa-f]{2}-[0-9A-Fa-f]{2}-[0-9A-Fa-f]{2}-[0-9A-Fa-f]{2}-[0-9A-Fa-f]{2}-[0-9A-Fa-f]{2})$/)
     {
       # print ("<LI>Removing file $PXETEMPLATEDIR/$newfn\n");
       &RunCommand("rm $PXETEMPLATEDIR/$newfn","Removing Mac template file $PXETEMPLATEDIR/$newfn");
     }
     if ($newfn =~ /^$template\.$/)
     {
       # print ("<LI>QnD Removing $PXETEMPLATEDIR/$newfn\n");
       &RunCommand("rm $PXETEMPLATEDIR/$newfn","Removing QnD template mac file $PXETEMPLATEDIR/$newfn");
     }

   }

  local($headerline)=$subs{__HEADER__};
  if ($#sublist > 0)
  {
    local($result)=open(PXEFILE,">$templatepxefile");

    local(@menuitem)=&GetConfigFile($PXESUBMENUHEADER);
    for $itemline (@menuitem)
    {
      local($newline)=&FindAndReplace($itemline,%info);
      print PXEFILE $newline ;
    }

    close(PXEFILE);

   for $cursubindex (sort(keys(%subsort)))
   {
     $item=$subsort{$cursubindex};
     if ($item ne "__HEADER__")
     {
       local(%subinfo)=&GetSubTemplateInfo($headerline,$subs{$item},%info);
       local($kernel)=&FindAndReplace($subinfo{KERNEL},%subinfo);
       local($append)=&FindAndReplace($subinfo{CMDLINE},%subinfo);
       local($result)=open(PXEFILE,">>$templatepxefile");
       local(@menuitem)=&GetConfigFile($PXESUBMENUITEM);
       for $itemline (@menuitem)
       {
         local($oldline)="";
         while ($oldline ne $itemline)
         {
           $oldline=$itemline;
           $itemline=&FindAndReplace($itemline,%subinfo);
         }
         print PXEFILE $itemline ;
       }
       close(PXEFILE);

       if (defined($subinfo{MAC}) && $subinfo{MAC} ne "")
       {
         local($MACFILE)=$PXETEMPLATEDIR."/".$subinfo{TEMPLATE}.".01-".$subinfo{MAC} ;
         local($result)=open(MF,">$MACFILE");
         print MF "MENU TITLE $item\n";
         print MF "DEFAULT $item\n";
         print MF "TIMEOUT 10\n";
         print MF "LABEL $item\n";
         print MF "  MENU LABEL default\n";
         print MF "  KERNEL $kernel\n";
         print MF "  APPEND $append\n";
         close(MF);
       }
     }
   }
 } else {
   $info{SUBTEMPLATE}="default";
   local($kernel)=&FindAndReplace($info{KERNEL},%info);
   local($append)=&FindAndReplace($info{CMDLINE},%info);
   local($result)=open(PXEFILE,">$templatepxefile");
   print PXEFILE "MENU TITLE Template $template\n";
   print PXEFILE "\n";
   print PXEFILE "DEFAULT default\n";
   print PXEFILE "TIMEOUT 1\n";
   print PXEFILE "LABEL default\n";
   print PXEFILE "  MENU LABEL default\n";
   if ($passwordenabled == 1)
   {
     print PXEFILE "  MENU PASSWD\n";
   }
   print PXEFILE "  KERNEL $kernel\n";
   print PXEFILE "  APPEND $append\n";
   close(PXEFILE);

  if (defined($info{MAC}) && $info{MAC} ne "")
  {
    local($MACFILE)=$PXETEMPLATEDIR."/".$info{TEMPLATE}.".01-".$info{MAC} ;
    local($result)=open(MF,">$MACFILE");
    print MF "DEFAULT default\n";
    print MF "TIMEOUT 10\n";
    print MF "LABEL default\n";
    print MF "  MENU LABEL default\n";
    print MF "  KERNEL $kernel\n";
    print MF "  APPEND $append\n";
    close(MF);
  }
 }
  return 0
}


1;
